"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Reducer = exports.Match = void 0;

const Reducer = pattern => line => {
  const regexp = pattern.global ? pattern : new RegExp(pattern, 'g');
  return line.match(regexp);
};

exports.Reducer = Reducer;

const Match = (pattern, data) => {
  if (!data) return [];
  const matches = data.map(Reducer(pattern)).flat();
  return [...new Set(matches)].filter(value => value);
};

exports.Match = Match;
//# sourceMappingURL=index.js.map