function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

export class Chain {
  constructor(nodes) {
    _defineProperty(this, "chain", void 0);

    if (nodes.length) {
      const entryPoint = nodes.shift();

      const reducer = (chain, handler, index) => {
        const next = chain.setNext(handler);
        return index === nodes.length - 1 ? entryPoint : next;
      };

      this.chain = nodes.reduce(reducer, entryPoint);
    }
  }

  async exec(data) {
    if (this.chain) {
      return await this.chain.handle(data);
    }

    return await Promise.resolve(null);
  }

}
//# sourceMappingURL=Chain.js.map