import { NativeModules, Platform } from 'react-native';
import { Match } from '../../utils';
const PdfExtractor = Platform.select({
  android: NativeModules.PdfExtractor,
  ios: {}
});
export class BaseExtractor {
  static async getUri() {
    return PdfExtractor.getUri();
  }

  static async isEncrypted() {
    return PdfExtractor.isEncrypted();
  }

  static async setUri(uri) {
    return PdfExtractor.setUri(uri);
  }

  static async getNumberOfPages(password) {
    return PdfExtractor.getNumberOfPages(password);
  }

  static async canIExtract() {
    return PdfExtractor.canIExtract();
  }

  static async getText(password) {
    const data = await PdfExtractor.getText(password);
    return [...new Set((data === null || data === void 0 ? void 0 : data.split('\n')) || [])];
  }

  static async getTextWithPattern(pattern, password) {
    const patterns = Array.isArray(pattern) ? pattern : [pattern];
    const data = await this.getText(password);
    const matches = patterns.map(regex => Match(regex, data));
    return [...new Set(matches)].flat();
  }

}
//# sourceMappingURL=Base.js.map