import type { ExtraTransient, Transient } from '../../types';
export declare class CommonExtractor {
    /**
     * Verifies if file exists based on URI gave
     * or got from intent provider (Android only)
     */
    static file(data: Transient): Promise<Transient>;
    /**
     * Checks if params satisfies full specification
     * to proceed with data extraction
     */
    static check(data: Transient): Promise<Transient>;
    /**
     * Checks if file is encrypted
     */
    static encrypted(data: Transient): Promise<Transient>;
    /**
     * Counts the number of pages
     */
    static pages(data: ExtraTransient): Promise<Transient>;
    /**
     * Applies matches
     */
    static matches(data: ExtraTransient): Promise<Transient>;
}
